# phpMyAdmin MySQL-Dump
# version 2.2.6
# http://phpwizard.net/phpMyAdmin/
# http://www.phpmyadmin.net/ (download page)
#
# Serveur: localhost
# Gnr le : Vendredi 03 Janvier 2003  16:26
# Version du serveur: 3.23.49
# Version de PHP: 4.2.0
# Base de donnes: `anomalie4`
# --------------------------------------------------------

#
# Structure de la table `autorisations`
#

DROP TABLE IF EXISTS autorisations;
CREATE TABLE autorisations (
  numero varchar(30) NOT NULL default '',
  type varchar(20) NOT NULL default '',
  KEY numero (numero,type)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Structure de la table `distances`
#

DROP TABLE IF EXISTS distances;
CREATE TABLE distances (
  etoile1 char(20) NOT NULL default '',
  etoile2 char(20) NOT NULL default '',
  distance_zap int(11) NOT NULL default '0',
  KEY etoile1 (etoile1,etoile2,distance_zap)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Structure de la table `fame`
#

DROP TABLE IF EXISTS fame;
CREATE TABLE fame (
  date int(11) NOT NULL default '0',
  gagnant1 varchar(20) NOT NULL default '',
  gagnant2 varchar(20) NOT NULL default '',
  gagnant3 varchar(20) NOT NULL default '',
  comment blob NOT NULL,
  KEY date (date)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Structure de la table `forums`
#

DROP TABLE IF EXISTS forums;
CREATE TABLE forums (
  ordre int(11) NOT NULL auto_increment,
  auteur varchar(20) NOT NULL default '',
  moment bigint(14) default NULL,
  sujet varchar(250) NOT NULL default '',
  texte blob NOT NULL,
  frequence varchar(20) NOT NULL default '',
  PRIMARY KEY  (ordre),
  UNIQUE KEY ordre_2 (ordre),
  KEY ordre (ordre),
  KEY frequence (frequence)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Structure de la table `joueurs`
#

DROP TABLE IF EXISTS joueurs;
CREATE TABLE joueurs (
  nom varchar(20) NOT NULL default '',
  prenom varchar(20) NOT NULL default '',
  email varchar(50) NOT NULL default '',
  login varchar(20) NOT NULL default '',
  pwd varchar(20) NOT NULL default '',
  date_tour bigint(20) default NULL,
  nrj_zap int(11) NOT NULL default '0',
  couleur varchar(6) NOT NULL default '',
  secondes int(11) NOT NULL default '0',
  techno int(11) NOT NULL default '0',
  creation int(11) NOT NULL default '0',
  ip varchar(20) NOT NULL default '',
  capitale varchar(20) default NULL,
  vote varchar(20) NOT NULL default '',
  etat varchar(5) NOT NULL default '',
  expire int(11) NOT NULL default '0',
  ip_lock varchar(20) NOT NULL default '',
  nb_echec int(11) NOT NULL default '0',
  date_lock int(11) NOT NULL default '0',
  PRIMARY KEY  (login),
  UNIQUE KEY login_2 (login),
  KEY login (login),
  KEY techno (techno),
  KEY creation (creation,ip),
  KEY capitale (capitale,vote),
  KEY etat (etat),
  KEY expire (expire),
  FULLTEXT KEY etat_2 (etat),
  KEY ip_lock (ip_lock,nb_echec,date_lock)
) TYPE=MyISAM PACK_KEYS=1;
# --------------------------------------------------------

#
# Structure de la table `journal`
#

DROP TABLE IF EXISTS journal;
CREATE TABLE journal (
  ordre int(11) NOT NULL auto_increment,
  ip varchar(20) NOT NULL default '',
  fqn text NOT NULL,
  origine text NOT NULL,
  horodate timestamp(14) NOT NULL,
  login varchar(20) NOT NULL default '',
  info text NOT NULL,
  navigateur varchar(132) NOT NULL default '',
  PRIMARY KEY  (ordre),
  UNIQUE KEY ordre_2 (ordre),
  KEY ordre (ordre,ip),
  KEY navigateur (navigateur)
) TYPE=MyISAM PACK_KEYS=1;
# --------------------------------------------------------

#
# Structure de la table `messages`
#

DROP TABLE IF EXISTS messages;
CREATE TABLE messages (
  msg blob NOT NULL,
  admin char(1) NOT NULL default '',
  login_dest varchar(20) NOT NULL default '',
  login_org varchar(20) default NULL,
  moment bigint(20) default NULL,
  KEY login_dest (login_dest),
  KEY moment (moment),
  KEY login_org (login_org)
) TYPE=MyISAM PACK_KEYS=1;
# --------------------------------------------------------

#
# Structure de la table `params`
#

DROP TABLE IF EXISTS params;
CREATE TABLE params (
  param varchar(20) NOT NULL default '',
  valeur text NOT NULL,
  PRIMARY KEY  (param),
  UNIQUE KEY param_2 (param),
  KEY param (param)
) TYPE=MyISAM PACK_KEYS=1;
# --------------------------------------------------------

#
# Structure de la table `rails`
#

DROP TABLE IF EXISTS rails;
CREATE TABLE rails (
  etoile1 char(20) NOT NULL default '',
  etoile2 char(20) NOT NULL default '',
  pseudo char(20) NOT NULL default '',
  KEY etoile1 (etoile1,etoile2,pseudo)
) TYPE=MyISAM PACK_KEYS=1;
# --------------------------------------------------------

#
# Structure de la table `scrutins`
#

DROP TABLE IF EXISTS scrutins;
CREATE TABLE scrutins (
  date bigint(14) NOT NULL default '0',
  premier varchar(20) NOT NULL default '',
  second varchar(20) NOT NULL default '',
  troisieme varchar(20) NOT NULL default '',
  origine varchar(20) NOT NULL default '',
  commentaire blob NOT NULL,
  pcent_1 tinyint(4) NOT NULL default '0',
  pcent_2 tinyint(4) NOT NULL default '0',
  pcent_3 tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (date),
  KEY date (date)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Structure de la table `systemes`
#

DROP TABLE IF EXISTS systemes;
CREATE TABLE systemes (
  x int(11) NOT NULL default '0',
  y int(11) NOT NULL default '0',
  dev int(11) NOT NULL default '1',
  dev_max int(11) NOT NULL default '1',
  nom char(20) NOT NULL default '',
  vaisseaux int(11) NOT NULL default '0',
  pseudo char(20) default NULL,
  PRIMARY KEY  (nom),
  KEY nom (nom),
  KEY x (x),
  KEY y (y),
  KEY pseudo (pseudo)
) TYPE=MyISAM PACK_KEYS=1;
# --------------------------------------------------------

#
# Structure de la table `vieux_class`
#

DROP TABLE IF EXISTS vieux_class;
CREATE TABLE vieux_class (
  joueur char(20) NOT NULL default '',
  couleur char(6) NOT NULL default '',
  etoile int(11) NOT NULL default '0',
  dev int(11) NOT NULL default '0',
  PRIMARY KEY  (joueur),
  UNIQUE KEY joueur_2 (joueur),
  KEY joueur (joueur,couleur,etoile,dev)
) TYPE=MyISAM PACK_KEYS=1;
# --------------------------------------------------------

#
# Structure de la table `vieux_joueurs`
#

DROP TABLE IF EXISTS vieux_joueurs;
CREATE TABLE vieux_joueurs (
  nom char(20) NOT NULL default '',
  prenom char(20) NOT NULL default '',
  email char(50) NOT NULL default '',
  login char(20) NOT NULL default '',
  pwd char(20) NOT NULL default '',
  couleur char(6) NOT NULL default '',
  PRIMARY KEY  (login),
  UNIQUE KEY login_2 (login),
  KEY login (login)
) TYPE=MyISAM PACK_KEYS=1;
# --------------------------------------------------------

#
# Structure de la table `vortex`
#

DROP TABLE IF EXISTS vortex;
CREATE TABLE vortex (
  origine char(20) NOT NULL default '',
  dest char(20) NOT NULL default '',
  pseudo char(20) NOT NULL default '',
  date_expire bigint(20) NOT NULL default '0',
  ordre int(11) NOT NULL auto_increment,
  PRIMARY KEY  (ordre),
  KEY origine (origine),
  KEY dest (dest),
  KEY pseudo (pseudo),
  KEY date_expire (date_expire),
  KEY ordre (ordre)
) TYPE=MyISAM PACK_KEYS=1;

