<?
/*
La 4e anomalie : real-time and web based galaxy conquest game. Have fun !
Copyright (C) 2003 

Sylvain Moreau F-78220  
email 1 : sylvainmoreau@wanadoo.fr
email 2 : smoreau@freesurf.fr

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA 02111-1307 USA
*/
include "param_top.php3";
define (PORTE_RADAR, 5);      // porte du radar
define (TERRA,1);
define (ATOM,2);
define (VORTEX,4);
define (HYPER,8);
define (RAIL,16);
define (PREPRO, 32);
define (PROTEC, 64);
define (CAPITALE, 128);
define (VOTE, 256);


//-----------------------------------------------
//  AFFICHE UN TEXTE AU JOUEUR
//-----------------------------------------------
function affiche($texte) {
    global $affichage;

    $affichage.=$texte;
    //journalise($texte);
    return $affichage;
}

//-----------------------------------------------
//  RETOURNE LE TEXTE A AFFICHER AU JOUEUR
//-----------------------------------------------
function get_affichage() {
    global $affichage;

    return $affichage;
}

//-----------------------------------------------
//  RETOURNE l'ANOMALIE EN COURS OU POSITIONNE UNE NOUVELLE VALEUR POUR L'ANOMALIE
//-----------------------------------------------
function anomalie($ano="") {
    return parametre("ANOMALIE",$ano);
}


//-----------------------------------------------
//  EFFACE LES VORTEX QUI ONT EXPIRE
//-----------------------------------------------
function efface_vortex() {

  $tim=time();
  $query="DELETE FROM vortex WHERE date_expire <=$tim";
  requete($query);
}


//-----------------------------------------------
//  GENERE UNE COULEUR SUR UNE BASE ALEATOIRE
//-----------------------------------------------
function genere_couleur(){
    mt_srand(time());
    $r=mt_rand(0,0xFF);
    $v=mt_rand(0,0xFF);
    $b=mt_rand(0,0xFF);
    $valeur=(($r*0xFF)+$v)*0xFF+$b;
    $couleur=sprintf("%06x",$valeur);
    return $couleur;
}



//-----------------------------------------------
//  TROUVE UNE COULEUR DE TEXTE LISIBLE EN FONCTION D'UNE COULEUR DE FOND
//-----------------------------------------------
function couleur_titrage($coul_fond){

   $coul_titre=sprintf("%06x",hexdec($coul_fond)^0xf0f0f0);
   return $coul_titre;
}

//-----------------------------------------------
//  CALCULE LA DISTANCE ENTRE DEUX POINTS
//-----------------------------------------------
function distance_espace($x1, $y1, $x2, $y2) {

   $dx2=pow($x1-$x2,2);
   $dy2=pow($y1-$y2,2);
   $dist=sqrt($dx2+$dy2);
   return $dist;
}



//-----------------------------------------------
//  RECUPERE LE NOMBRE DE POINTS DE POUVOIR POLITIQUE D'UN JOUEUR
//-----------------------------------------------
function points_zap($joueur) {

   $query = "SELECT nrj_zap FROM joueurs WHERE login=\"$joueur\"";
   $result=requete($query);
   $row = mysql_fetch_row($result);
   $nrj_zap=$row[0];
   return($nrj_zap);
}



//-----------------------------------------------
//  MODIFIE LE NOMBRE DE POINTS DE POUVOIR POLITIQUE D'UN JOUEUR
//-----------------------------------------------
function maj_points_zap($joueur, $nrj_zap) {

   $query = "UPDATE joueurs SET nrj_zap=$nrj_zap WHERE login=\"$joueur\"";
   requete($query);
}


//-----------------------------------------------
//  INDIQUE SI UN JOUEUR A UN NIVEAU TECHNO DONNE
//-----------------------------------------------
function a_techno($joueur, $techno) {
    static $tech;
    static $login;

    if ($login <> $joueur) {
      $login="";
      $tech="";
    }
    if ($tech=="") {
      connecte();
      $query= "SELECT techno FROM joueurs WHERE login=\"$joueur\"";
      $result = requete($query);
      $existe = (mysql_num_rows($result) != 0);
      if ($existe) {
       $row= mysql_fetch_row($result);
       $tech=$row[0];
       $login=$joueur;
      }
    }
    if ($tech!="")
      $result = (($tech&$techno)!=0);
    else
      $result= 0;
    //mysql_close();
    return $result;
}

//-----------------------------------------------
//  Indique si une toile doit changer d'autorit en fonction d'une diffrence de nb de vaisseaux
//-----------------------------------------------
function proba_changer($vaisseaux){

   $divise=pow($vaisseaux,.5);
   if($divise>0)
     $proba=100/$divise;
   else
     $proba=100;
   $proba_finale = mini(95, maxi(5,$proba-10));
   return($proba_finale);
}
//-----------------------------------------------
//  MET A JOUR LE NIVEAU TECHNOLOGIQUE D'UN JOUEUR
//-----------------------------------------------
function maj_techno($joueur) {

  $ano=anomalie(); // Cette fonction ouvre et ferme la base contrairement  la fonction message
  connecte();
  // Recuperer les paramtres
  $query = "SELECT SUM(dev), techno FROM joueurs, systemes WHERE pseudo=\"$joueur\" AND pseudo=login GROUP BY pseudo";
  $result = requete($query);
  if(mysql_num_rows($result) == 0) {// Le joueur n'a pas d'toile
    $som_dev=0;
    $query2 = "SELECT techno FROM joueurs WHERE login=\"$joueur\"";
    $result2 = requete($query2);
    $row2= mysql_fetch_row($result2);
    $tech=$row2[0];
  }
  else {
    $row= mysql_fetch_row($result);
    $som_dev=$row[0];
    $tech=$row[1];
  }
  // Calculer les variations
  // TERRAFORMAGE ?
  if (($tech&TERRA) && ($som_dev <SEUIL_TERRA) && ($joueur <> "Empire")) { // Le terraformage tait  matris et on en perd la maitrise. L'empire a toujours le terraformage
     message("",$joueur, "Votre niveau de dveloppement conomique ne vous permet plus de matriser le terraformage !");
     $tech &=~TERRA;
     $query = "UPDATE joueurs SET techno=$tech WHERE login=\"$joueur\"";
     requete($query);
  }
  if (!($tech&TERRA) && ($som_dev >= SEUIL_TERRA)) { // On acquiert la matrise du terraformage
     message("",$joueur, "Votre niveau de dveloppement conomique vous permet de maitriser le terraformage !");
     $tech |=TERRA;
     $query = "UPDATE joueurs SET techno=$tech WHERE login=\"$joueur\"";
     requete($query);
  }
  // ATOMISATION ?
  if (($tech&ATOM) && ($som_dev <SEUIL_ATOM)) { // L'atomisation tait  matris et on en perd la maitrise
     message("",$joueur, "Votre niveau de dveloppement conomique ne vous permet plus de maitriser l'atomisation de systmes !");
     $tech &=~ATOM;
     $query = "UPDATE joueurs SET techno=$tech WHERE login=\"$joueur\"";
     requete($query);
  }
  if (!($tech&ATOM) && ($som_dev >= SEUIL_ATOM) && ($ano >=4)) { // On acquiert la matrise de l'atomisation
     message("",$joueur, "Votre niveau de dveloppement conomique vous permet de maitriser l'atomisation de systmes !");
     $tech |=ATOM;
     $query = "UPDATE joueurs SET techno=$tech WHERE login=\"$joueur\"";
     requete($query);
  }
  // VORTEX ?
   if (($tech&VORTEX) && ($som_dev <SEUIL_VORTEX)) { // Le vortex tait  matris et on en perd la maitrise
     message("",$joueur, "Votre niveau de dveloppement conomique ne vous permet plus de maitriser le vortex");
     $tech &=~VORTEX;
     $query = "UPDATE joueurs SET techno=$tech WHERE login=\"$joueur\"";
     requete($query);
   }
   if (!($tech&VORTEX) && ($som_dev >= SEUIL_VORTEX) && ($ano >=3)) { // On acquiert la matrise du vortex
     message("",$joueur, "Votre niveau de dveloppement conomique vous permet de maitriser le vortex !");
     $tech |=VORTEX;
     $query = "UPDATE joueurs SET techno=$tech WHERE login=\"$joueur\"";
     requete($query);
   }

   // HYPERFORMAGE ?
   if (($tech&HYPER) && ($som_dev <SEUIL_HYPER) && ($joueur <> "Empire")) { // L'hyperformage tait  matris et on en perd la maitrise
     message("",$joueur, "Votre niveau de dveloppement conomique ne vous permet plus de matriser l'HYPERformage !");
     $tech &=~HYPER;
     $query = "UPDATE joueurs SET techno=$tech WHERE login=\"$joueur\"";
     requete($query);
  }
  if (!($tech&HYPER) && ($som_dev >= SEUIL_HYPER)) { // On acquiert la matrise du terraformage
     message("",$joueur, "Votre niveau de dveloppement conomique vous permet de maitriser l'HYPERformage !");
     $tech |=HYPER;
     $query = "UPDATE joueurs SET techno=$tech WHERE login=\"$joueur\"";
     requete($query);
  }

   // RAIL STELLAIRE ?
   if (($tech&RAIL) && ($som_dev <SEUIL_RAIL)) { // L'hyperformage tait  matris et on en perd la maitrise
     message("",$joueur, "Votre niveau de dveloppement conomique ne vous permet plus de matriser le rail stellaire !");
     $tech &=~RAIL;
     $query = "UPDATE joueurs SET techno=$tech WHERE login=\"$joueur\"";
     requete($query);
  }
  if (!($tech&RAIL) && ($som_dev >= SEUIL_RAIL)) { // On acquiert la matrise du terraformage
     message("",$joueur, "Votre niveau de dveloppement conomique vous permet de maitriser le rail stellaire !");
     $tech |=RAIL;
     $query = "UPDATE joueurs SET techno=$tech WHERE login=\"$joueur\"";
     requete($query);
  }


     // PROTECTORAT POSSIBLE  ?
   if (($tech&PREPRO) && !($tech&PROTEC) && ($som_dev <SEUIL_PROTEC)) { // Le protectorat tait possible mais il n'est plus propos par les Prolarch'
     message("",$joueur, "Les Prolarch' vous font savoir qu'il ne vous proposent plus leur protectorat");
     $tech &=~PREPRO;
     $query = "UPDATE joueurs SET techno=$tech WHERE login=\"$joueur\"";
     requete($query);
  }
  if (!($tech&PREPRO) && ($som_dev >= SEUIL_PROTEC) && ($ano >=4)) { // Les Prolarch' proposent un protectorat
     message("",$joueur, "Les Prolarch' vous proposent leur protectorat. Si vous l'acceptez, vous ne pourrez plus tre atomis si vous vous engagez en retour  ne pas en faire usage.");
     $tech |=PREPRO;
     $query = "UPDATE joueurs SET techno=$tech WHERE login=\"$joueur\"";
     requete($query);
  }


  // CAPITALE  ?
  if (($tech&CAPITALE) && ($som_dev <SEUIL_CAPITALE)) { // La capitale tait matris et on en perd la maitrise
     message("",$joueur, "Votre niveau de dveloppement conomique ne vous permet plus de supporter le cout d'une capitale galactique !");
     $tech &=~CAPITALE;
     $query = "UPDATE joueurs SET techno=$tech, capitale=\"\", vote=\"\" WHERE login=\"$joueur\"";
     requete($query);
  }
  if (!($tech&CAPITALE) && ($som_dev >= SEUIL_CAPITALE) && ($joueur <> "Empire")) { // On acquiert la matrise de la capitale galactique
     message("",$joueur, "Votre niveau de dveloppement conomique vous permet de suporter le cout d'une capitale galactique !");
     $tech |=CAPITALE;
     $query = "UPDATE joueurs SET techno=$tech, capitale=\"\" WHERE login=\"$joueur\"";
     requete($query);
  }

  // VOTE ?
  if ($tech&VOTE) {
    if ($som_dev <SEUIL_VOTE) // A-t-on le niveau suffisant ?
      $perd_vote=1;  // Non -> retirer le droit de vote
    else {
      $query="SELECT * FROM joueurs WHERE capitale=\"\" and login=\"$joueur\"";
      $result=requete($query);
      if (mysql_num_rows($result)<> 0) // Une capitale est-elle nomme ?
        $perd_vote=1;  // Oui -> retirer le droit de vote
      else
        $perd_vote=0;  // Non-> ne rien faire car on n'avait pas le droit de vote
    }
    if ($perd_vote==1) { // Le vote tait matris et on en perd la maitrise
     message("",$joueur, "Votre empire n'est plus assez important pour avoir le droit de vote !");
     $tech &=~VOTE;
     $query = "UPDATE joueurs SET techno=$tech, vote=\"\" WHERE login=\"$joueur\"";
     requete($query);
    }
  }


  if (!($tech&VOTE) && ($som_dev >= SEUIL_VOTE) && ($joueur <> "Empire")) { // On acquiert la matrise du vote ?
     $query="SELECT * FROM joueurs WHERE capitale<>\"\" and login=\"$joueur\"";
     $result=requete($query);
     if (mysql_num_rows($result)<> 0) { // Il y a une capitale, il y a donc bien droit de vote
       message("",$joueur, "Votre empire est maintenant assez important pour aqurir le droit de vote.");
       $tech |=VOTE;
       $query = "UPDATE joueurs SET techno=$tech, vote=\"$joueur\" WHERE login=\"$joueur\"";
       requete($query);
     }
  }
  //mysql_close();
}

//-----------------------------------------------
//  Monte une opration de rbellion sur une toile
//-----------------------------------------------
function rebellion($login, $etoile) {
   connecte();
   // On verifie si l'ordre est acceptable
   $query = "SELECT pseudo, s.nom, vaisseaux, dev, capitale FROM systemes s, joueurs j WHERE s.nom=\"$etoile\" AND pseudo<>\"$login\" AND pseudo=login";
   $result=requete($query);
   if (mysql_num_rows($result)== 0) affiche("<B> Cette toile est inconnue ou bien elle vous appartient dj ! </B>");
   else {// Vrifier si assez de pouv politique
     $nrj_zap= points_zap($login);
     if ($nrj_zap < ZAP_REBELLION) affiche("<B> Vous n'avez pas assez de pouvoir politique </B>");
     else {// Tout est OK, on va passer l'ordre
       maj_points_zap($login, $nrj_zap-ZAP_REBELLION);
       $row = mysql_fetch_row($result);
       $pseudo=$row[0];
       $nom=$row[1];
       $vaisseaux=$row[2];
       $dev=$row[3];
       $capitale=$row[4];

       mt_srand(time());
       $perte_vx=mini($vaisseaux, mt_rand(1,3)); // On calcule les effets de la rebellion
       $reste_vaisseaux=$vaisseaux-$perte_vx;
       $msg_org="Votre opration de rebellion sur $etoile  fait perdre $perte_vx vaisseau(x)  $pseudo sur cette toile.";
       $msg_dest="Il y a eu une rebellion sur $etoile qui vous a fait perdre $perte_vx vaisseau(x).";

       if($reste_vaisseaux<=8 && strcasecmp($nom,$capitale)!=0){ // On calcule si l'toile change d'autorit
          $proba=proba_changer($reste_vaisseaux*2);
          $hasard=mt_rand(0,100);
          if($hasard <$proba) {// Changement d'autorit !
            $nouv_pseudo=$login;
            $msg_org.=" Les pertes parmis vos partisants ont t lourdes mais il ont russit  prendre l'toile !";
            $msg_dest.=" Malgr une lutte acharne de vos forces, les rebelles ont gagn. $etoile appartient maintenant  $login!";
          }
          else { // Pas de changement d'autorit
           $nouv_pseudo=$pseudo;
           $msg_dest.=" Vous tes quasiment sur que c'est un coup de $login ...";
          }
       }
       else
         $nouv_pseudo=$pseudo; // On ne change pas d'autorit
       $query="UPDATE systemes SET pseudo=\"$nouv_pseudo\", vaisseaux=$reste_vaisseaux WHERE nom=\"$etoile\"";
       $result=requete($query);
       affiche("$msg_org<BR>");
       message("",$login,$msg_org);
       message("",$pseudo,$msg_dest);
      }
   }
}


//-----------------------------------------------
//  Lance une opration de propagande
//-----------------------------------------------
function propagande($login) {
   connecte();
   // On verifie si l'ordre est acceptable
   $nrj_zap= points_zap($login);
   if ($nrj_zap < ZAP_PROPAGANDE) affiche("<B> Vous n'avez pas assez de pouvoir politique </B>");
   else {// Tout est OK, on va passer l'ordre
     maj_points_zap($login, $nrj_zap-ZAP_PROPAGANDE);
     $limite=time()-10*TOUR*24;
     $query="SELECT DISTINCT login, pwd FROM joueurs, systemes WHERE login=pseudo AND login<>\"Empire\" AND (date_tour <= $limite OR etat='A')ORDER BY date_tour DESC";
     $result = requete($query);
     if (mysql_num_rows($result)==0) affiche("Votre coup de propagande  t sans effet !");
     else { // Prendre toute les toiles de ce joueur
        $row = mysql_fetch_row($result);
        $joueur=$row[0];
        $pwd=$row[1];
        $query2="UPDATE systemes SET pseudo=\"$login\", vaisseaux=least(3*dev_max+2, vaisseaux) WHERE pseudo=\"$joueur\"";
		requete($query2);
        message("",$joueur,"Votre population n'a pas supporte que vous l'abandonniez. Elle a profite d'un coup de propagande de $login pour reconnaitre son autorit.");
        $msg="La population de toutes les toiles de $joueur ont t sensibles  votre coup de propagande. Elle reconnaissent maintenant votre autorit";
        affiche("$msg<BR>");
        message("",$login, $msg);
     }
   }
}
//-----------------------------------------------
//  Gnre le message de base des rapports d'espionnage. Cette fonction est impotrante pour que les
// faux rapports ne soient pas diffrents des vritables rapports !
//-----------------------------------------------
function msg_espion_base($nom, $pseudo, $vais, $dev, $dev_max) {
    $msg="$nom reconnait l'autorit de $pseudo, elle est protge par $vais vaisseau(x), ";
    $msg.=" a un dveloppement conomique de $dev et un developpement conomique maximal de $dev_max. ";
    return $msg;
}


//-----------------------------------------------
//  Espionne une toile
//-----------------------------------------------
function espionner($login, $etoile) {
   connecte();
   // On verifie si l'ordre est acceptable
   $query = "SELECT pseudo, nom, vaisseaux, dev, dev_max FROM systemes WHERE nom=\"$etoile\"";
   $result=requete($query);
   if (mysql_num_rows($result)== 0) affiche("<B> Cette toile est inconnue ! </B>");
   else {// Vrifier si assez de pouv politique
     $nrj_zap= points_zap($login);
     if ($nrj_zap < ZAP_ESPION) affiche("<B> Vous n'avez pas assez de pouvoir politique </B>");
     else {// Tout est OK, on va passer l'ordre
       maj_points_zap($login, $nrj_zap-ZAP_ESPION);
       $row = mysql_fetch_row($result);
       $pseudo=$row[0];
       $nom=$row[1];
       $vaisseaux=$row[2];
       $dev=$row[3];
       $dev_max=$row[4];
       // gnre le rapport de base
       $msg=msg_espion_base($nom, $pseudo, $vaisseaux, $dev, $dev_max);
       // Y-a-t il des vortex ?
       efface_vortex(); // Effacer les vortex qui ont expirs
       $query="SELECT date_expire, dest, origine  FROM vortex WHERE dest=\"$etoile\" OR origine=\"$etoile\"";
       $result=requete($query);
       while($row = mysql_fetch_row($result)) {
         $date_expire=$row[0];
         $dest=$row[1];
         $origine=$row[2];
         $msg.=" Il y a un vortex entre $origine et $dest, il expire le ".date_to_string($date_expire).".";
       }
       // Y'a t-il des rails ?
       $query="SELECT etoile1, etoile2  FROM rails WHERE etoile1=\"$etoile\" OR etoile2=\"$etoile\"";
       $result=requete($query);
       while($row = mysql_fetch_row($result)) {
           $etoile1=$row[0];
           $etoile2=$row[1];
           $msg.=" Il y a un rail stellaire entre $etoile1 et $etoile2.";
       }
       // Faire le rapport !
       if ($vaisseaux > 7) // La tentative d'espionnage  t detecte
         message("",$pseudo,"Vous avez attrap des espions sur $nom ! Il travaillaient pour $login");
         
       // Les espions disent n'importe quoi ?
       $proba=100-proba_changer($vaisseaux/2);
       mt_srand(time());
       $hasard=mt_rand(0,100);
       if($hasard <$proba) {
          $vais=mt_rand(0,30);
          $devel=mt_rand(0,15);
          $dev_maxi=maxi($devel,mt_rand(0,15));
          $msg = msg_espion_base($nom, $pseudo, $vais, $devel, $dev_maxi);
       }
       affiche("$msg<BR>");
       message("",$login,$msg);
     }
   }
}


//-----------------------------------------------
//  Convoque l'assemble galactique
//-----------------------------------------------
function convoquer($login) {
   connecte();
   // On verifie si l'ordre est acceptable
   $nrj_zap= points_zap($login);
   if ($nrj_zap < ZAP_CONVOQUER) affiche("<B> Vous n'avez pas assez de pouvoir politique </B>");
   else { // Tout est OK, on va faire les modifs dans la BD
     maj_points_zap($login, $nrj_zap-ZAP_CONVOQUER);
     // Mettre  jour les niveau techno des votants
     $query="SELECT login FROM joueurs where vote<>\"\"";
     $result=requete($query);
     while($row = mysql_fetch_row($result)) {
       $joueur=$row[0];
       maj_techno($joueur);
     }
     // On y va !
     message("","","$login  convoqu l'assemble galactique pour dcider qui doit diriger les forces de l'empire. ");
     // Calcul du nom de votants
     $query="SELECT count(*)  FROM joueurs WHERE vote <>\"\"";
     $result=requete($query);
     $row = mysql_fetch_row($result);
     $nb_votant=$row[0];

     if ($nb_votant <5) { // Le scrutin est annul faute de votants
       $premier="";
       $pcent_1=0;
       $second="";
       $pcent_2=0;
       $troisieme="";
       $pcent_3=0;
       $commentaire="Le scrutin a t annul car il n'y a eu que $nb_votant votant(s) et il en faut au moins 5.";
     }
     else {
       // Calcul du total des voix exprimes
       $query="SELECT sum(dev)+count(pseudo)  FROM systemes, joueurs WHERE pseudo=login AND  vote <>\"\"";
       $result=requete($query);
       $row = mysql_fetch_row($result);
       $total_exprime=$row[0];
       // Calcul du rsultat du vote
       $query="SELECT vote, sum(dev)+count(pseudo) s FROM systemes, joueurs WHERE login=pseudo AND vote <>\"\" GROUP BY vote ORDER BY s DESC";
       $result=requete($query);
       $i=1;
       while(($row = mysql_fetch_row($result)) && $i <=3){
         $resultat[$i]=$row[0];
         $nb_voix[$i]=$row[1];
         $i++;
       }
       $premier=$resultat[1];
       $pcent_1=100*$nb_voix[1]/$total_exprime;

       $second=$resultat[2];
       $pcent_2=100*$nb_voix[2]/$total_exprime;

       $troisieme=$resultat[3];
       $pcent_3=100*$nb_voix[3]/$total_exprime;

       if ($pcent_1 < (100*1/3))  // Le scrutin est invalid faute de reprsentativit
         $commentaire="$premier n'a pas atteint le tiers des voix exprimes, le scrutin a t annul.";
       else { // Le vote  t gagn !!
         $commentaire="$premier a remport le scrutin  la majorit";
         mt_srand(time());
         $hasard=mt_rand(0,100000);
         $pwd_empire="pwd".$hasard;
         $query="UPDATE joueurs SET pwd=\"$pwd_empire\" where login=\"Empire\"";
         $result=requete($query);
         $ancien_elu=parametre("ELU");
         if ($ancien_elu<>$premier) {
            parametre("ELU",$premier);
            if ($ancien_elu<>"")
              message("",$ancien_elu,"Vous avez t dchu de vos fonctions par l'assemble galactique. vous ne dirigez plus les forces de l'empire");
         }

         message("",$premier,"Le mot de passe de l'empire est $pwd_empire. Pour plus de facilit vous pouvez changer ce mot de passe.");
       }
       $date=time();
       $query="INSERT INTO scrutins (date, premier, second, troisieme, origine, commentaire, pcent_1, pcent_2, pcent_3) VALUES ($date, \"$premier\", \"$second\", \"$troisieme\", \"$login\", \"$commentaire\", $pcent_1, $pcent_2, $pcent_3)";
       $result=requete($query);
     }
     message("","",$commentaire);
   }
}

//-----------------------------------------------
//  Fait voter un joueur
//-----------------------------------------------
function voter($login, $bulletin){
    connecte();
    // On verifie si l'ordre est acceptable
    $query = "SELECT * FROM joueurs, systemes WHERE pseudo=\"$bulletin\" AND login=\"$bulletin\" AND login<>\"Empire\"";
    $result=requete($query);
    if (mysql_num_rows($result)== 0) affiche("<B> Vous pouvez pas voter pour \"$bulletin\" ! Soit c'est interdit, soit il n'existe pas soit il n'a pas d'toiles. </B>");
    else { // Tout est OK, on va faire les modifs dans la BD
      $query="UPDATE joueurs SET vote=\"$bulletin\" WHERE login=\"$login\"";
      $result=requete($query);
    }
}



//-----------------------------------------------
//  Calcule les effets d'une perte de capitale suite a une destitution
//-----------------------------------------------
function anarchie($login){

  connecte();
  mt_srand(time());

  $liste="\"vide\"";
  $query = "SELECT nom, vaisseaux FROM systemes WHERE pseudo=\"$login\"";
  $result=requete($query);
  while($row = mysql_fetch_row($result)){
    $nom=$row[0];
    $vaisseaux=$row[1];

    $proba=proba_changer($vaisseaux);
    $hasard=mt_rand(0,100);
    if ($hasard<$proba) {
      $liste.=", \"$nom\""; // Construire la liste des toile a faire changer d'autorit
    }
  }
  if ($liste<>"\"vide\"") {
    $query2="UPDATE systemes SET pseudo=\"Empire\" WHERE nom IN($liste)";
    $result2=requete($query2);
    $liste=str_replace("\"vide\",","",$liste); // On retire la valeur d'initialisation
    $liste=str_replace("\"","",$liste); // On retire les guillements qui taient ncssaires pour la requete SQL
    message("",$login,"La population de n'a pas compris pourquoi elle n'a plus de capitale, le(s) systeme(s) de $liste prfrent retourner sous le joug de l'empire");
  }
}
//-----------------------------------------------
//  Suite  une prise de capitale, fait changer une liste d'toile d'autorit
//-----------------------------------------------
function change_autorite($login, $liste, $vainqueur){
    $query="UPDATE systemes SET pseudo=\"$vainqueur\" WHERE nom IN($liste)";
    $result=requete($query);
    $liste=str_replace("\"vide\",","",$liste); // On retire la valeur d'initialisation
    $liste=str_replace("\"","",$liste); // On retire les guillements qui taient ncssaires pour la requete SQL
    message("",$login,"La population n'a pas compris pourquoi elle n'a plus de capitale, le(s) systeme(s) de $liste prfre(nt) reconnaitre l'autorit de $vainqueur");
    message("",$vainqueur,"La population du vilain $login vous reconnait et le(s) systme(s) de $liste se range(nt)  vos cots");
}

//-----------------------------------------------
//  Calcule les effets d'une prise de capitale par l'ennemi
//-----------------------------------------------
function prise_capitale($login, $vaiss_capitale, $vainqueur){
    
  connecte();
  mt_srand(time());

  $liste1="\"vide\""; // liste des toiles qui se rebellent vers l'attaquant
  $liste2="\"vide\""; // Liste des toiles qui se rebellent vers un autre joueur

  // Choisir un perso autre que l'attaquant et le dfenseur vers lesquelles les toiles peuvent se rebeller
  $query = "SELECT pseudo FROM systemes WHERE pseudo<>\"$login\" AND pseudo<>\"$vainqueur\"";
  $result= requete($query);
  $nb_systemes=mysql_num_rows($result);
  $hasard=mt_rand(0,$nb_systemes-1);
  mysql_data_seek($result,$hasard);
  $row = mysql_fetch_row($result);
  $veinard = $row[0]; // C'est vers lui que les toiles vont se rebeller si elle ne reste pas au perdant et ne vont pas au vainqueur

  // Parcourir toute les toiles pour calculer la rebellion
  $query = "SELECT nom, vaisseaux, dev FROM systemes WHERE pseudo=\"$login\"";
  $result=requete($query);
  while($row = mysql_fetch_row($result)){
    $nom=$row[0];
    $vaisseaux=$row[1];
    $dev=$row[2];

    $proba=100-proba_changer($vaiss_capitale-($dev+$vaisseaux));
    $hasard=mt_rand(0,100);

    if ($hasard<$proba) {
      $hasard2=mt_rand(0,100);
      if ($hasard2 <=25)// Construire la liste des toiles a faire changer d'autorit
        $liste2.=", \"$nom\"";  // L'toile va dans le camp du veinard
      else
        $liste1.=", \"$nom\"";  // L'toile va dans le camp de l'attaquant
    }
  }
  if ($liste1<>"\"vide\"")
    change_autorite($login, $liste1, $vainqueur);
  if ($liste2<>"\"vide\"")
    change_autorite($login, $liste2, $veinard);
}

//-----------------------------------------------
//  NOMMER UNE CAPITALE
//-----------------------------------------------
function capitale($login, $etoile){

  connecte();
  // On verifie si l'ordre est acceptable
  $query = "SELECT nom FROM systemes WHERE nom=\"$etoile\" AND pseudo=\"$login\"";
  $result=requete($query);
  if (mysql_num_rows($result)== 0 && $etoile<>"anarchie") affiche("<B> Vous ne possedez pas \"$etoile\" ! </B>");
  else {
    $row= mysql_fetch_row($result);
    $nom_etoile=$row[0];
    $query= "SELECT capitale, vote FROM joueurs WHERE login=\"$login\" and capitale=\"$etoile\"";
    $result=requete($query);
    if (mysql_num_rows($result)!= 0) affiche("<B> \"$etoile\" est dj votre capitale ! </B>");
    else {
      $row = mysql_fetch_row($result);
      $vote=$row[0];;
      $nrj_zap= points_zap($login);
      if ($nrj_zap < ZAP_CAPITALE) affiche("<B> Vous n'avez pas assez de pouvoir politique </B>");
      else {// Tout est OK, on va faire les modifs dans la BD
        maj_points_zap($login, $nrj_zap-ZAP_CAPITALE);
        if ($etoile=="anarchie") {
          anarchie($login);
          $etoile="";
          $vote="";
        }
        $query= "UPDATE joueurs SET capitale=\"$nom_etoile\", vote=\"$vote\" WHERE login=\"$login\"";
        $result=requete($query);
      }
    }
  }
}


//-----------------------------------------------
//  COLONISER UN SYSTEME
//-----------------------------------------------
function coloniser($login, $etoile){
  connecte();
  // On verifie si l'ordre est acceptable
  $query = "SELECT dev_max, vaisseaux FROM systemes WHERE nom=\"$etoile\" AND pseudo=\"$login\"";
  $result=requete($query);
  if (mysql_num_rows($result)== 0) affiche("<B> Vous ne possedez pas $etoile ! </B>");
  else {
    $row = mysql_fetch_row($result);
    $dev_max=$row[0];
    $vaisseaux=$row[1];
    if ($dev_max>0) affiche("<B> Vous ne pouvez pas coloniser une toile avec un dveloppement maximal non nul ! </B>");
    elseif ($vaisseaux<3) affiche("<B> Vous n'avez pas assez de vaisseaux en orbite ! </B>");
    else {// on verifie si je joueur a assez de pouvoir politique
      $nrj_zap= points_zap($login);
      if ($nrj_zap < ZAP_COLO) affiche("<B> Vous n'avez pas assez de pouvoir politique </B>");
      else {// Tout est OK, on va faire les modifs dans la BD
        maj_points_zap($login, $nrj_zap-ZAP_COLO);
        $query= "UPDATE systemes SET dev = 1, dev_max=1, vaisseaux=vaisseaux-3 WHERE nom=\"$etoile\"";
        requete($query);
      }
    }
  }
  //mysql_close
}

//-----------------------------------------------
//  PLACE UN JOUEUR SOUS PROTECTORAT PROLARCH'
//-----------------------------------------------
function protectorat($login){
   // On verifie si l'ordre est acceptable
   // on verifie si le joueur a assez de pouvoir politique
   $nrj_zap= points_zap($login);
   if ($nrj_zap < ZAP_PROTEC) affiche("<B> Vous n'avez pas assez de pouvoir politique </B>");
   else {// Tout est OK, on va faire les modifs dans la BD
      maj_points_zap($login, $nrj_zap-ZAP_PROTEC);
      // On rcupre le niveau techno dans $tech
      $query="SELECT techno FROM joueurs WHERE login=\"$login\"";
      $result=requete($query);
      $row= mysql_fetch_row($result);
      $tech=$row[0];
      $tech |=PROTEC;
      $query = "UPDATE joueurs SET techno=$tech WHERE login=\"$login\"";
      requete($query);
  }
}
//-----------------------------------------------
//  CREE UN RAIL STELLAIRE ENTRE DEUX SYSTEMES
//-----------------------------------------------
function creer_rail($login, $etoile1, $etoile2){
  // On verifie si l'ordre est acceptable
  $query = "SELECT nom, vaisseaux FROM systemes WHERE (nom=\"$etoile1\" OR nom=\"$etoile2\") AND pseudo=\"$login\"";
  $result=requete($query);
  if (mysql_num_rows($result)!= 2) affiche("<B> Vous devez posseder $etoile1 et $etoile2 ! </B>");
  else{ // Les systemes appartiennent au joueur alors qu'il y a assez de vaisseaux
    $row = mysql_fetch_row($result);
    $systeme1=$row[0];
    $vaisseaux_systeme1=$row[1];
    $row = mysql_fetch_row($result);
    $systeme2=$row[0];
    $vaisseaux_systeme2=$row[1];
    if ($vaisseaux_systeme1<VAIS_RAIL || $vaisseaux_systeme2<VAIS_RAIL) affiche("<B> Vous n'avez pas assez de vaisseaux sur $etoile1 et $etoile2</B>");
    else { // L'ordre est coherent
        // on verifie si le joueur a assez de pouvoir politique
        $nrj_zap= points_zap($login);
        if ($nrj_zap < ZAP_RAIL) affiche("<B> Vous n'avez pas assez de pouvoir politique </B>");
        else {// Tout est OK, on va faire les modifs dans la BD
          maj_points_zap($login, $nrj_zap-ZAP_RAIL);
          $query= "INSERT INTO rails (etoile1, etoile2, pseudo) VALUES (\"$systeme1\", \"$systeme2\",\"$login\")";
          requete($query);
          $query= "UPDATE systemes set vaisseaux=vaisseaux-".VAIS_RAIL." WHERE nom=\"$systeme1\" OR nom=\"$systeme2\"";
          requete($query);
          affiche("<B> Le rail stellaire est cr.</B>");
        }
    }
  }
}


//-----------------------------------------------
//  HYPERFORMER UN SYSTEME
//-----------------------------------------------
function hyperformer_systeme($login, $etoile){
  connecte();
  // On verifie si l'ordre est acceptable
  $query = "SELECT nom FROM systemes WHERE nom=\"$etoile\" AND pseudo=\"$login\"";
  $result=requete($query);
  if (mysql_num_rows($result)== 0) affiche("<B> Vous ne possedez pas \"$etoile\" ! </B>");
  else {// on verifie si je joueur a assez de pouvoir politique
    $nrj_zap= points_zap($login);
    if ($nrj_zap < ZAP_HYPER) affiche("<B> Vous n'avez pas assez de pouvoir politique </B>");
    else {// Tout est OK, on va faire les modifs dans la BD
      maj_points_zap($login, $nrj_zap-ZAP_HYPER);
      $query= "UPDATE systemes SET dev_max=dev_max+1 WHERE nom=\"$etoile\"";
      requete($query);
    }
  }
  //mysql_close();
}

//-----------------------------------------------
//  ATOMISER UN SYSTEME
//-----------------------------------------------
function atomiser_systeme($login, $etoile) {
  connecte();
  // On verifie si l'ordre est acceptable
  $query = "SELECT s.pseudo, j.capitale FROM systemes s, joueurs j WHERE s.nom=\"$etoile\" and j.login=s.pseudo";
  $result=requete($query);
  if (mysql_num_rows($result)== 0) affiche("<B> \"$etoile\" n'existe pas! </B>");
  else {
    $row= mysql_fetch_row($result);
    $joueur_cible=$row[0];
    $capitale=$row[1];
    // on verifie si je joueur a assez de pouvoir politique
    $nrj_zap= points_zap($login);
    if ($nrj_zap < ZAP_ATOM) affiche("<B> Vous n'avez pas assez de pouvoir politique </B>");
    else {// Tout est OK, on va faire les modifs dans la BD
      maj_points_zap($login, $nrj_zap-ZAP_ATOM);
      // On vrifie si le joueur cible est sous protectorat
      if (a_techno($joueur_cible,PROTEC)) {
        affiche("Les Prolarch vous avertissent que $joueur_cible est sous leur protectorat.");
        affiche("Votre attaque  t neutralise");
        message("",$login,"Les Prolarch vous avertissent que $joueur_cible est sous leur protectorat.");
        message("",$joueur_cible,"$login  essay d'atomiser $etoile mais les Prolarch' vous ont protg !");
      }
      else
        {
        // On vrifie s'il y a un retour de bton !
        mt_srand(time());
        $hasard=mt_rand(0,100);
        if ($hasard <=10) { // Il y a un retour de bton, la bombe explose dans le camps de l'attaquant
          $query="SELECT s.nom FROM systemes s, joueurs WHERE pseudo=\"$login\" AND login=pseudo AND s.nom<>capitale";
          $result = requete($query);
          $indice_systeme = mt_rand(0,mysql_num_rows($result)-1); //prend une plante au hasard
          mysql_data_seek($result,$indice_systeme);
          $row = mysql_fetch_row($result);
          $systeme = $row[0];
          // Dtruit l'toile
          $query = "DELETE FROM systemes WHERE nom=\"$systeme\"";
          $result = requete($query);
          affiche("<B>Comme quoi la technologie Prolarch' rserve des suprises...<BR></B>");
          affiche("Vos forces ont fait une mauvaise manipulation qui ont atomis $systeme qui vous appartenait !");
          message("",$login,"Vos forces ont fait une mauvaise manipulation qui ont atomis $systeme qui vous appartenait !");
         }
        else {
          $query="DELETE FROM systemes WHERE nom=\"$etoile\"";
          requete($query);
          affiche("<B>$etoile n'existe plus. Elle appartenait  $joueur_cible. </B>");
          if ($login==$joueur_cible)
            message("",$login,"Vous avez d sombrer dans la folie et vous avez dtruit $etoile qui reconnaissait votre autorit");
          else {
            message("",$login,"Vous avez atomis $etoile qui appartenait  $joueur_cible");
            message("",$joueur_cible,"$login  transform $etoile en un champs d'astriodes !!");
          }
          if (strcasecmp(ltrim(rtrim($etoile)),ltrim(rtrim($capitale)))==0) { // On vrifie si la cible est la capitale
              message("",$joueur_cible,"Vous n'avez plus de capitale !!");
              anarchie($joueur_cible);
              $query="UPDATE joueurs SET capitale=\"\", vote=\"\" WHERE login=\"$joueur_cible\"";
              requete($query);
          }
          // vrifier si 2e retour de bton
          $hasard=mt_rand(0,100);
          if ($hasard <=5) { // Perte de pouvoir politique suplmentaire
             maj_points_zap($login, 0);
             affiche("L'atomisation de $etoile  provoqu des rvoltes sur vos toiles. Vous avez russi  les contenir mais cela vous  cout la totalit de vos points de pouvoir politique.");
             message("",$joueur_cible,"Ceci  provoqu des meutes chez $login");
          }
          // Dans tous les cas prvenir la galaxie
          message("","",$login." a dcid de rayer une toile de la carte de la galaxie ! Paix aux mes de ses habitants");
       }
     }
    }
  }
  //mysql_close();
}


//-----------------------------------------------
//  TERRAFORMER UN SYSTEME
//-----------------------------------------------
function terraformer_systeme($login, $etoile, $valide){

  connecte();
  // On verifie si l'ordre est acceptable
  $query = "SELECT nom, dev_max FROM systemes WHERE nom=\"$etoile\" AND pseudo=\"$login\"";
  $result=requete($query);
  if (mysql_num_rows($result)== 0) affiche("<B> Vous ne possedez pas $etoile ! </B>");
  else {// on verifie si je joueur a assez de pouvoir politique
    $row = mysql_fetch_row($result);
    $dev_max=$row[1];
    $nrj_zap= points_zap($login);
    if ($nrj_zap < ZAP_TERRA) affiche("<B> Vous n'avez pas assez de pouvoir politique </B>");
    else // On vrifie s'il n'y a pas de btises (ie terraformer une toile a fort dev)
      if ($dev_max >5 && $valide<>"ok") {
         $msg=" <P><B> Vos ingnieurs vous rapellent que cette toile  un dveloppement conomique maximal de $dev_max.";
         $msg.=" Si vous tes certain de vouloir passer cet ordre, confirmez le en tapant <U>ok</U> et en validant.</B></P>";
         $msg.="<FORM Method=\"POST\" Action=\"login.php3\" target=_top>";
           $msg.="<INPUT type=hidden Name=ordre value = TERRAFORMER>";
           $msg.="<INPUT type=hidden name=cmd value=ordre>";
           $msg.="<INPUT type=hidden size=10 name=arg1 value=$etoile>";
           $msg.="<INPUT type=text size=10 name=arg2 value=Niet>";
           $msg.="<INPUT type=hidden size=10 name=arg3 value=\"\">";
           $msg.="<INPUT type=submit value=\"Valider !\">";
         $msg.="</FORM>";
         affiche($msg);
        }
      else {// Tout est OK, on va faire les modifs dans la BD
        maj_points_zap($login, $nrj_zap-ZAP_TERRA);
        mt_srand(time());
        $dev_max= mt_rand(0,4);
        if ($dev_max == 0) affiche("<B>Votre tentative de terraformage est un fiasco !</B><BR>");
          affiche("<B> Votre systme possde maintenant $dev_max plantes habitables </B> <BR>");
          $query= "UPDATE systemes SET dev_max=$dev_max, dev=0 WHERE nom=\"$etoile\"";
          requete($query);
      }
  }
  //mysql_close();
}


//-----------------------------------------------
//  OUVRE UN VORTEX ENTRE DEUX SYSTEMES
//-----------------------------------------------
function ouvre_vortex($login, $origine, $dest){

  connecte();
  // On verifie si l'ordre est acceptable
  $query = "SELECT nom FROM systemes WHERE nom=\"$origine\" AND pseudo=\"$login\"";
  $result=requete($query);
  if (mysql_num_rows($result)== 0) affiche("<B> Vous ne possedez pas $origine ! </B>");
  else{ // Le systeme appartient au joueur alors On verifie si le systeme de destination existe
    $row = mysql_fetch_row($result);
    $syst_origine=$row[0];
    $query = "SELECT  nom FROM systemes WHERE nom=\"$dest\"";
    $result=requete($query);
    if (mysql_num_rows($result)== 0) affiche("<B> Le systme de destination n'existe pas !</B>");
    else { // L'ordre est coherent
        $row = mysql_fetch_row($result);
        $syst_dest=$row[0];
        // on verifie si je joueur a assez de pouvoir politique
        $nrj_zap= points_zap($login);
        if ($nrj_zap < ZAP_VORTEX) affiche("<B> Vous n'avez pas assez de pouvoir politique </B>");
        else {// Tout est OK, on va faire les modifs dans la BD
          maj_points_zap($login, $nrj_zap-ZAP_VORTEX);
          $date_expire=time()+3600*TEMPS_VORTEX;
          $query= "INSERT INTO vortex (origine, dest, pseudo, date_expire) VALUES (\"$syst_origine\", \"$syst_dest\",\"$login\",$date_expire)";
          requete($query);
          affiche("<B> Le vortex  t ouvert</B>");
        }
    }
  }
  //mysql_close();
}




//-----------------------------------------------
//  DEPLACE UNE FLOTTE D'UN SYSTEME A UN AUTRE
//-----------------------------------------------
function deplace_flotte($login, $origine, $dest, $nb_flotte) {

  if ($nb_flotte <=0 || !strcasecmp(chop($origine), chop($dest))) {
      affiche(" <B><BR> Cet ordre n'a pas de sens !!<BR><B>");
      return;
  }
  connecte();
  // On verifie si l'ordre est acceptable
  $query = "SELECT vaisseaux, x, y FROM systemes WHERE nom=\"$origine\" AND pseudo=\"$login\"";
  $result=requete($query);
  if (mysql_num_rows($result)== 0) affiche("<B> Vous ne possedez pas ce systeme ! </B>");
  else { // Le systeme appartient au joueur
    $row = mysql_fetch_row($result);
    $vaisseaux_org=$row[0];
    $x_org=$row[1];
    $y_org=$row[2];
    if ($vaisseaux_org < $nb_flotte) affiche("<B> Vous n'avez pas assez de vaisseaux en orbite </B>");
    else {// On verifie si le systme de destination existe
      $query = "SELECT  vaisseaux, x, y, pseudo, dev FROM systemes WHERE nom=\"$dest\"";
      $result=requete($query);
      if (mysql_num_rows($result)== 0) affiche("<B> Le systme de destination n'existe pas !</B>");
      else { // L'ordre est coherent, on verifie si je joueur a assez de pouvoir politique
        $row = mysql_fetch_row($result);
        $vaisseaux_dest=$row[0];
        $x_dest=$row[1];
        $y_dest=$row[2];
        $joueur_dest=$row[3];
        $dev =$row[4];
        // Y a t-il un rail stellaire entre les systemes ?
        $query2="SELECT * FROM rails WHERE (etoile1=\"$origine\" AND etoile2=\"$dest\") OR (etoile1=\"$dest\" AND etoile2=\"$origine\")";
        $result2=requete($query2);
        if (mysql_num_rows($result2)!= 0) $rail=1;
        else $rail = 0;
        if ($rail==1){ // Il y a un rail le cout du dplacement est celui du rail
          $zap_depl=ZAP_DEPL_RAIL;
          affiche("<B>Il y a un rail stellaire entre $origine et $dest.</B><BR>");
        }else { // On va vrifier s'il y a un vortex
          // y a t-il un vortex entre les systemes ?
          efface_vortex(); // Effacer les voxtex expirs avant de faire les vrifications
          $query2="SELECT * FROM vortex WHERE (origine=\"$origine\" AND dest=\"$dest\") OR (origine=\"$dest\" AND dest=\"$origine\")";
          $result2=requete($query2);
          if (mysql_num_rows($result2)!= 0) $vortex=1;
          else $vortex = 0;
          if ($vortex==1) {
            $zap_depl=ZAP_DEPL_VORTEX;
            affiche("<B>Il y a un vortex entre $origine et $dest.</B><BR>");
          }
          else { // On n'a pas de Vortex, Le cout politique depend de la distance entre les systemes
            $distance=distance_espace($x_org,$y_org,$x_dest,$y_dest);
            $distance2=pow($distance,2);
            $zap_depl= round($distance2 + 0.4); // Ceil() prend l'entier suprieur : ceil((float)2)=3,or on veut arrondir vers le "haut"
          }
        }
        $nrj_zap= points_zap($login);
        if ($nrj_zap < $zap_depl) affiche("<B> Vous n'avez pas assez de pouvoir politique </B>");
        else {// Tout est OK, on va faire les modifs dans la BD
          // mise a jour des points de pouvoir politique
          $nrj_zap = $nrj_zap-$zap_depl;
          maj_points_zap($login, $nrj_zap);
          if ($origine==$dest) // Si le dplacement n'en est pas un mettre a jour les vaisseaux de destination
              $vaisseaux_dest-=$vaisseaux_org;
          // Retirer la flotte du systeme
          $vaisseaux_org-= $nb_flotte;
          $query = "UPDATE systemes SET vaisseaux = $vaisseaux_org WHERE nom=\"$origine\"";
          $result=requete($query);

          // S'il y a un vortex, calculer et appliquer l'attrition
          if ($vortex==1) {
            mt_srand(time());
            $perte=mt_rand(0,round($nb_flotte*COEF_PERTE_VORTEX+0.4));
            $nb_flotte-= $perte;
            affiche("<B>Durant le voyage, $perte vaisseaux se perdent dans le warp !</B><BR>");
          }
          // Changer les caracteristiques du systeme de destination
          if ($login == $joueur_dest) { // Il s'agit d'un deplacement a l'interieur d'un empire
           // Ajouter la flotte au systeme de destination
           $vaisseaux_dest+=$nb_flotte;
           $query = "UPDATE systemes SET vaisseaux = $vaisseaux_dest WHERE nom=\"$dest\"";
           $result=requete($query);
           }
          else {// Il s'agit d'une attaque

           // Decider qui gagne
           $force_org=$nb_flotte;
           $force_dest=$vaisseaux_dest*1.1;
           $vaisseaux_org = (int) max(0,floor($nb_flotte - $force_dest));
           if ($vaisseaux_org > 0) {// L'attaquant gagne
              $vaisseaux_reste=$vaisseaux_org;
              $gagnant = $login;
              $msg = "Vous avez pris  $joueur_dest le systme $dest que $vaisseaux_dest vaisseaux dfendaient.";
              affiche("<b>$msg</b>");
              message("",$gagnant,$msg);
              message("",$joueur_dest,"L'affreux $login a pris le systeme de $dest par la force avec $nb_flotte vaisseaux");
              // On vrifie si c'est une prise de capitale
              $query="SELECT capitale FROM joueurs WHERE login=\"$joueur_dest\" and capitale=\"$dest\"";
              $result=requete($query);
              if (mysql_num_rows($result)> 0) {
                  prise_capitale($joueur_dest,$vaisseaux_reste, $gagnant);
                  $query="UPDATE joueurs SET capitale=\"\", vote=\"\" WHERE login=\"$joueur_dest\"";
                  $result=requete($query);
              }
           }
           else {// le defenseur gagne
              $vaisseaux_reste= max(0,$vaisseaux_dest-$nb_flotte);
              $gagnant=$joueur_dest;
              affiche("<B> Vous avez chou dans votre attaque, vous vous tes heurt  $vaisseaux_dest vaisseaux. </b>");
              $perte = $vaisseaux_dest-$vaisseaux_reste;
              message("",$joueur_dest,"Le risible $login a tent de prendre $dest par la force mais il a chou. Vous avez perdu $perte vaisseau(x)");
           }
                 // Degrader l'economie suite aux combats
           if ($dev >0) { // L'etoile a bien une conomie
              $dev--;
              affiche("<BR><B>Les combats ont atteint l'conomie de l'toile</B><BR>");
              message("",$joueur_dest, "L'attaque a rduit la capacit conomique de $dest");
           }    // Mise a jour dans le systeme
           $query = "UPDATE systemes SET vaisseaux = $vaisseaux_reste, pseudo=\"$gagnant\", dev=$dev WHERE nom=\"$dest\"";
           $result=requete($query);
          }
        }
      }
    }
  }
  //mysql_close();
}

//-----------------------------------------------
//  ENVOIE UN MESSAGE A UN AUTRE JOUEUR
//-----------------------------------------------
function envoyer_message($origine, $dest, $msg) {

  connecte();
  // On verifie si l'ordre est acceptable
  $query="SELECT * FROM joueurs WHERE login=\"$dest\"";
  $result=requete($query);
  if (mysql_num_rows($result)== 0) affiche("<B> Vous ne pouvez envoyer un message a un joueur qui n'existe pas </B>");
  else // Tout est OK, on va faire les modifs dans la BD
     message($origine, $dest, $msg);
  //mysql_close();
}

//-----------------------------------------------
//   SUREXPLOITE UN SYSTEME EN ECHANGE DE VAISSEAUX
//-----------------------------------------------
function surexploite_systeme($login,$systeme){

  connecte();
  // On verifie si l'ordre est acceptable
  $query = "SELECT dev_max, dev, nom, vaisseaux FROM systemes WHERE nom=\"$systeme\" AND pseudo=\"$login\"";
  $result=requete($query);
  if (mysql_num_rows($result)== 0) affiche("<B> Vous ne possedez pas ce systme ! </B>");
  else { // Le systeme appartient au joueur
    $row = mysql_fetch_row($result);
    $dev_max = $row[0];
    $dev = $row[1];
    $nom = $row[2];
    $vaisseaux = $row[3];
    if ($dev_max <1) affiche("<B> Ce systeme n'est pas assez dvelopp !<B>");
    else { // L'ordre est coherent, on verifie si je joueur a assez de pouvoir politique
        $nrj_zap= points_zap($login);
        if ($nrj_zap < ZAP_SUREX) affiche("<B> Vous n'avez pas assez de pouvoir politique </B>");
        else {// Tout est OK, on va faire les modifs dans la BD
          // mise a jour des points de pouvoir politique
          $nrj_zap = $nrj_zap-ZAP_SUREX;
          maj_points_zap($login, $nrj_zap);
          // mise a jour des niveaux de developpement (max et nominaux)
          $dev_max=$dev_max-1;
          $dev = mini($dev, $dev_max);
          $vaisseaux = $vaisseaux+3;
          $query = "UPDATE systemes SET dev_max=$dev_max, dev=$dev, vaisseaux=$vaisseaux WHERE nom=\"$nom\"";
          requete($query);
          affiche("Opration russie");
        }
    }
  }
  //mysql_close();
}

//-----------------------------------------------
//  LANCE LA PRODUCTION DE VAISSEAUX
//-----------------------------------------------
function produit_vaisseaux($login, $etoile) {

  connecte();
  // on verifie si je joueur a assez de pouvoir politique
  $query = "SELECT nrj_zap FROM joueurs WHERE login=\"$login\"";
  $result=requete($query);
  $row = mysql_fetch_row($result);
  $nrj_zap=$row[0];
  if ($nrj_zap < ZAP_PROD) affiche("<B> Vous n'avez pas assez de pouvoir politique </B>");
  else { // On vrifie si l'etoile appartient au joueur
    $query = "SELECT nom, vaisseaux, dev FROM systemes WHERE pseudo = \"$login\" AND nom=\"$etoile\"";
    $result = requete($query);
    if (mysql_num_rows($result)== 0) affiche("<B> Vous ne possedez pas ce systme ! </B>");
    else { // Tout est OK, on va faire les modifs dans la BD
    // Mise a jour du nombre de vaisseaux
    $row = mysql_fetch_row($result);
    $nom = $row[0];
    $vaisseaux = $row[1];
    $dev = $row[2];
    $vaisseaux += $dev;
    $query = "UPDATE systemes SET vaisseaux=$vaisseaux WHERE nom=\"$nom\"";
    requete($query);
    // mise a jour des points de pouvoir politique
    $nrj_zap = $nrj_zap-ZAP_PROD;
    maj_points_zap($login, $nrj_zap);
    affiche("Opration russie");
    }
  }
  //mysql_close();
}

//-----------------------------------------------
//  DEVELOPPE UN SYSTEME CONTRE UN VAISSEAU
//-----------------------------------------------
function developpe_systeme($login,$systeme){

  connecte();
  // On verifie si l'ordre est acceptable
  $query = "SELECT dev_max, dev, vaisseaux FROM systemes WHERE nom=\"$systeme\" AND pseudo=\"$login\"";
  $result=requete($query);
  if (mysql_num_rows($result)== 0) affiche("<B> Vous ne possedez pas ce systeme ! </B>");
  else {  // Le systeme appartient au joueur
    $row = mysql_fetch_row($result);
    $dev_max = $row[0];
    $dev = $row[1];
    $vaisseaux = $row[2];
    if ($dev >= $dev_max) affiche("<B> Ce systeme a deja atteint son developpement maximal</B>");
    elseif ($vaisseaux <1 ) affiche("<B> Vous n'avez pas assez de vaisseaux en orbite </B>");
    else { // L'ordre est coherent, on verifie si je joueur a assez de pouvoir politique
        $nrj_zap = points_zap($login);
        if ($nrj_zap < ZAP_DEV) affiche("<B> Vous n'avez pas assez de pouvoir politique </B>");
        else { // Tout est OK, on va faire les modifs dans la BD
          // mise a jour des points de pouvoir politique
          $nrj_zap = $nrj_zap-ZAP_DEV;
          maj_points_zap($login, $nrj_zap);
          // Mise a jour du nombre de vaisseaux et du niveau de developpement
          $dev=$dev+1;
          $vaisseaux =$vaisseaux-1;
          $query = "UPDATE systemes SET dev=$dev, vaisseaux=$vaisseaux WHERE nom=\"$systeme\"";
          requete($query);
          affiche("Opration russie");
        }
    }
  }
  //mysql_close();
}


//-----------------------------------------------
//   DEPOSE UN MESSAGE A UN JOUEUR
//       Si l'emetteur ($org) est vide, c'est un message administratif
//-----------------------------------------------

function message($org, $dest, $msg) {
  if ($org=="")
     $admin =1;
  else
     $admin=0;
  $tim = time();
  $query = "INSERT INTO messages (msg, admin, login_dest, login_org, moment) VALUES (\"$msg\",$admin, \"$dest\", \"$org\", $tim)";
  requete($query);
}


//-----------------------------------------------
//   DEPOSE UN MESSAGE A TOUS LES JOUEURS SOUS LE COMPTE DE l'EMPIRE
//-----------------------------------------------

function megaphone($login, $msg) {

    $qui_pilote=parametre("ELU");
    if ($qui_pilote<>"" && $login!="")
        $texte="(sous le contrle de ".$qui_pilote.") : ".$msg;
    else
        $texte=$msg;
    message($login,"",$texte);
}

//-----------------------------------------------
// TROUVE UNE ETOILE A ATTRIBUER A UN NOUVEAU JOUEUR
//    Retourne le nom de l'toile si elle est trouve
//    et "" sinon
//-----------------------------------------------

function trouve_etoile_libre()  {
    // Une toile est libre lorsqu'elle appartient  l'empire ou  un joueur
    // qui n'a pas jou depuis plus de 10 jours (ou 10 fois 24 tours) et qui est
    // a plus de 7 AL d'un joueur qui a plus de 5 jours
    $limite_last=time()-10*TOUR*24;
    $limite_age=time()-5*TOUR*24;
    $liste_imunite="\"vide\"";
    // Mettre dans la table tmp la liste des toiles ligibles.
    $query= "CREATE TEMPORARY TABLE tmp (nom char(20) NOT NULL, creation INT(11), date_tour  BIGINT(20), KEY nom(nom), KEY creation (creation), KEY date_tour (date_tour))";
    $result = requete($query);
    $query= "INSERT INTO tmp (nom, creation, date_tour) SELECT systemes.nom, creation, date_tour  FROM systemes, joueurs WHERE pseudo=login AND (login='Empire' OR  date_tour < $limite_last)";
    $result = requete($query);
    // Selectionner les etoiles non ligibles a cause de la proximit
    $query="SELECT DISTINCT etoile1 FROM distances, systemes s, joueurs j, tmp t WHERE etoile1=t.nom AND etoile2=s.nom AND s.pseudo <> 'Empire' AND s.pseudo=j.login AND j.creation > $limite_age AND distance_zap <=49";
    $result = requete($query);
    $liste_trop_pres="\"vide\"";
    while($row = mysql_fetch_row($result)){ // Construire la liste des etoiles non ligibles a fause de la proximit
         $nom=$row[0];
         $liste_trop_pres.=", \"$nom\"";
    }
    // Retirer les toiles immuniss contre l'apparition de nouveaux (ie etoiles trop proches des joueurs rcents
    $query ="DELETE FROM tmp WHERE nom IN ($liste_trop_pres)";
    $result = requete($query);
    // Selection les etoiles  tirer au sort
   $query="SELECT nom FROM tmp";
   $result = requete($query);
   $nb_systemes=mysql_num_rows($result);
   if ($nb_systemes==0) { // Il n'y a pas de systeme de libre
        $systeme="";
   }else { // Il y a de la place
      if ($nb_systemes==1) $indice_systeme=0;
      else {
        // Prendre un systme au hasard
        srand(time());
        $indice_systeme = rand(0,mysql_num_rows($result)-1);
      }
      mysql_data_seek($result,$indice_systeme);
      $row = mysql_fetch_row($result);
      $systeme = $row[0];
   }
   return $systeme;
}
//-----------------------------------------------
// CREE UN JOUEUR SANS LUI ATTRIBUER D'ETOILE
//
//-----------------------------------------------
function cree_joueur_sans_etoile($login, $pwd) {
   global $REMOTE_ADDR;

   // Insere le joueur dans la table
   $date_tour = time();
   $couleur=genere_couleur();
   $login= strip_tags($login);
   $creation=time();
   $ip=$REMOTE_ADDR;

   $query = "INSERT INTO joueurs (login, pwd, date_tour, nrj_zap, couleur, techno, creation, ip) VALUES (\"$login\", \"$pwd\", $date_tour, 70,\"$couleur\", 0, $creation,\"$ip\")";
   requete($query);
   journalise("cration de $login, mot de passe $pwd");
}

//-----------------------------------------------
// GENERATION D'UN JOUEUR
//    Quand $pnj (pesonnage non joueur) est vrai on n'attribue pas de systeme
//    et on ne laisse pas de message
//    Retourne vrai si le joueur est cr
//    Nb les pnj sont toujours crs
//-----------------------------------------------

function genere_joueur($login, $pwd, $pnj) {
// FAIRE LES VERIF AVANT ET RECUPERER LES INFO DU JOUEUR QUI SE FAIT DEPOSSEDER !!
   if ($pnj) { // C'est un joueur sans toile
   cree_joueur_sans_etoile($login, $pwd);
   }else { // Creer le joueur si on lui trouve une toile
     $systeme = trouve_etoile_libre();
     if ($systeme!="") { // Il y a une toile de libre
       // Creer le joueur sans son toile
       cree_joueur_sans_etoile($login, $pwd);
       // Trouver le propritaire
       $query = "SELECT pseudo FROM systemes WHERE nom=\"$systeme\"";
       $result = requete($query);
       $row = mysql_fetch_row($result);
       $pseudo=$row[0];
       // Fait changer l'etoile d'autorite et alloue 3 vaisseaux
       $query = "UPDATE systemes SET pseudo=\"$login\", vaisseaux = 3 WHERE nom=\"$systeme\"";
       $result = requete($query);
       // Laisse un message a l'ancien propritaire et au nouveau
       message("",$pseudo,"Le systeme $systeme s'est rebell contre votre autorite tyranique !");
       message ("",$login,"Vous avez pris la tte des rebelles du systeme $systeme et vous avez arrach cette toile des griffes de l'infme $pseudo");
     } else { // Il n'y a pas de place !
         echo "<H2>Dsol mais il n'y a pas de place disponible dans ce jeu. Vous n'avez pas t inscrit. Revenez plus tard !</H2>";
     }
   }
  return (($systeme!="") || $pnj);
}

//-----------------------------------------------
//  CHANGE LE MOT DE PASSE D'UN JOUEUR
//-----------------------------------------------
function change_pwd($joueur, $ancpwd, $pwd){
     connecte();
     $query = "UPDATE joueurs SET pwd=\"$pwd\" WHERE login=\"$joueur\" AND pwd=\"$ancpwd\"";
     $result = requete($query);
     journalise("$joueur  chang de mot de passe : $pwd");
	 $query= "SELECT * FROM joueurs WHERE login=\"$joueur\" AND pwd=\"$pwd\"";
	 if (mysql_num_rows(requete($query))==0) return 0;
	 else return 1;
     //mysql_close();
}

//-----------------------------------------------
//  Fait abdiquer un joueur
//-----------------------------------------------
function abdique($joueur, $pwd){
     connecte();
     $query = "SELECT * from joueurs where login=\"$joueur\" AND pwd=\"$pwd\"";
     $result = requete($query);
     if (mysql_num_rows($result)==0) {
         echo "Le mot de passe n'est pas le bon !";
         journalise("erreur de mot de passe pour faire abdiquer $joueur : $pwd");
         $erreur=1;
       }
     else  { // Marquer le joueur en attente d'abdication
	   $date_expire=time()+TAMPON_ABDIQUE;
       $query = "UPDATE joueurs SET etat='A', expire=$date_expire WHERE login=\"$joueur\" AND login <> 'Empire'";
       $result = requete($query);
	   // retirer tous les PP !
	   maj_points_zap($joueur,0);
       journalise("$joueur a abdiqu - temporisation active");
       $erreur=0;
      }
     //mysql_close();
     return $erreur;
}

//-----------------------------------------------
//  Fait Retourner  l'empire toute les toile des joueurs abdiqu 
//  dont la priode tampon  expire
//-----------------------------------------------
function purge_abdique(){

    connecte();
	// Rcuprer la liste des joueurs a abdiquer
	$liste="\"\"";
	$moment=time();
	$query = "SELECT login FROM joueurs WHERE etat ='A' AND expire < $moment";
	$result = requete($query);
	while($row = mysql_fetch_row($result)){
	  $log_joueur=$row[0];
      $liste .=", \"$log_joueur\""; // Faire voluer la liste des joueurs concerns         
	}
	// Les faire abdiquer
    $query = "UPDATE systemes SET pseudo=\"Empire\", vaisseaux=least(3*dev_max+2, vaisseaux) WHERE pseudo in ($liste)";
    $result = requete($query);
	// Les marquer comme n'tant plus en attente d'abdication
	$query="UPDATE joueurs SET etat ='X' WHERE login in ($liste)";
	$result = requete($query);
}

//-----------------------------------------------
//  GENERATION DES ETOILES
//-----------------------------------------------

function genere_systemes($maxX, $maxY, $nbEtoiles) {

$consonnes =array("b", "c", "d", "f", "g", "j", "k", "l","m", "n", "p", "r", "s", "t", "v", "w", "x", "z");
$voyelles= array("a","e","i","o","u");
srand(time());

// Efface tous les systemes existants et les distances
connecte();
$query="DELETE FROM systemes";
requete($query);
$query="DELETE FROM distances";
requete($query);
  for($etoile = 1; $etoile<=$nbEtoiles; $etoile++) {

// Calcule les coordonnes en excluant les doublons
     do {
       $x=rand(0,$maxX);
       $y=rand(0,$maxY);
    } while($coord[$x][$y]);
    $coord[$x][$y]=1;

// Trouve un nom en excluant les doublons
    do {
      $nom ="";
      for ($i=1; $i<=3; $i++) {
       $nom=$nom.$consonnes[rand(0,17)];
       $nom=$nom.$voyelles[rand(0,4)];
      }
    } while($systemes[$nom]);
    $systemes[$nom]=1;
    $nom = ucfirst($nom); // Met la premiere lettre en majuscule

// Genere les vaisseaux
    $alea = rand(0,100);
    if ($alea <20) 
       $vaisseaux =1;
    elseif ($alea <80)
       $vaisseaux =2;
    else
       $vaisseaux = 3;

// Calcule le developpement maximal
   $alea = rand(0,100);
    if ($alea <20) 
       $devMax =1;
    elseif ($alea <80)
       $devMax=2;
    else
       $devMax= 3;
// Calcul le developpement actuel
   $dev=floor($devMax/2);

// genere l'odre SQL pour inserer le systeme dans la base de donnees    
    $query="INSERT systemes (x, y, dev, dev_max, nom, vaisseaux, pseudo) VALUES ($x, $y, $dev, $devMax, \"$nom\", $vaisseaux, \"Empire\")";
    requete($query);
    }
// genrre la table des distances  moins de 50 points zap (ou points politiques)
    $query="INSERT INTO distances (etoile1, etoile2, distance_zap) ";
    $query.="SELECT distinct s1.nom, s2.nom, (pow(s1.x-s2.x,2)+pow(s1.y-s2.y,2)) dis ";
    $query.="FROM systemes s1, systemes s2 HAVING dis <=50";
    requete($query);
}

//-----------------------------------------------
//  GENERE TOUTE LA PARTIE
//-----------------------------------------------
function genere_partie () {

   ignore_user_abort(1); // on veut etre sur de ne pas tre drang !
   connecte();
   // efface tous les joueurs aprs les avoir sauvs
   $query="DELETE FROM vieux_joueurs";
   requete($query);
   $query="INSERT INTO vieux_joueurs (email, login, pwd) SELECT email, login, pwd FROM joueurs";
   requete($query);
   $query="DELETE FROM joueurs";
   requete($query);
   //efface tous les scrutins
   $query="DELETE from scrutins";
   requete($query);
   //efface tous les forums
   $query="DELETE from forums";
   requete($query);
   //efface tous les messages
   $query="DELETE from messages";
   requete($query);
   //efface tous les vortex
   $query="DELETE FROM vortex";
   requete($query);
   //efface tous les rails
   $query="DELETE FROM rails";
   requete($query);
   //efface les vieux logs
   $query="select max(ordre) from journal";
   $result=requete($query);
   $row = mysql_fetch_row($result);
   $ordre=maxi(0, $row[0]-1000);
   $query="DELETE FROM journal WHERE ordre <$ordre";
   requete($query);
   // efface les vieux parametres
   $etat_inscritions=parametre("next_inscript");
   $query="DELETE FROM params";
   requete($query);
   // Changer l'tat des inscriptions
   parametre("inscript",$etat_inscritions);
   parametre("next_inscript",$etat_inscritions);
   journalise("*** Reset de la partie ***");
   // cree les joueurs indispensables :
   //   - Empire qui controle toutes les etoiles. Rebelle est en fait un personnage
   //     non joueur qui est cre pour faciliter les traitements et eviter qu'un joueur ne
   //     cree un login avec ce nom !!
   //   - Dieu qui ne joue pas mais permet de reinitialiser le jeu
   //   - Prolarch'
   mt_srand(time());
   $hasard=mt_rand(0,100000);
   $pwd="pwd".$hasard;
   genere_joueur("Empire",$pwd,1);
   genere_joueur("Dieu",PDW_DIEU,1);
   $hasard=mt_rand(0,100000);
   $pwd="pwd".$hasard;
   genere_joueur("Prolarch'",$pwd,1);
   //mysql_close;

   // Positionne les nouveaux parametres
   anomalie(2);// On commence avec le niveau d'anomalie 2
   parametre("etoiles_max",MAX_ETOILES);
   // efface et genere le plateau de jeu
   genere_systemes(100, 100, MAX_ETOILES);
   // Positionne les nouvelles technnos
   copy("core/next_param_techno.php3", "core/param_techno.php3");
   
   
}

//-----------------------------------------------
//  RECALCULE LES POINTS ZAP D'UN JOUEUR
//-----------------------------------------------

function calcule_zap($joueur) {

  // Mettre a jour l'etat de son compte et l'afficher
  // rcuperer le niveau de dveloppement maximal total de la galaxie
  $query= "SELECT SUM(dev_max) FROM systemes";
  $result= requete($query);
  $row = mysql_fetch_row($result);
  $max_dev_galaxie = $row[0]; // point de dev cumul maximal statistique

  //rcuprer les infos du joueur
  $query="SELECT date_tour, nrj_zap, secondes, capitale, etat FROM joueurs WHERE login =\"$joueur\"";
  $result= requete($query);
  $row = mysql_fetch_row($result);
  $date_tour = $row[0];
  $nrj_zap = $row[1];
  $secondes =$row[2];
  $capitale=$row[3];
  $etat=$row[4];
  $tim=time();

  // rcuperer le niveau de developpement cumul du joueur
  if ($joueur=="Empire")
    $som_dev=0; // L'empire est toujours considr comme ayant un empire  zro=> pas de bonus !
  else {
    $query="SELECT sum(dev) FROM systemes WHERE pseudo =\"$joueur\"";
    $result= requete($query);
    if (mysql_num_rows($result)== 0)
      $som_dev=0; // Le joueur n'a plus d'toile
    else {
      $row = mysql_fetch_row($result);
      $som_dev=$row[0];
    }
  }

  $ratio_bonus = COEF_BONUS_ZAP * $som_dev/$max_dev_galaxie;
  if ($capitale<>"") // Effet de la capitale sur les points politiques
     $ratio_bonus*=BONUS_ZAP_CAPITALE;

  $delta_secondes_brut = max(0,$tim-$date_tour);
  $delta_secondes = $delta_secondes_brut *(1+ $ratio_bonus)+$secondes;
  $delta_zap = max(0,round($delta_secondes/TOUR-0.5));
  $reste_seconde = $delta_secondes-$delta_zap*TOUR;
  if ($etat=='A' || $etat=='X') $new_zap=0; // Les abdiqus ne gagnent pas de PP
  else $new_zap=mini($nrj_zap+$delta_zap,maxi($nrj_zap,MAX_ZAP));
  
  $query ="UPDATE joueurs SET date_tour = $tim, nrj_zap=$new_zap, secondes=$reste_seconde WHERE login=\"$joueur\" AND etat <>'A' AND  etat <>'X'";
  $result= requete($query);
    // Affiche le resultat
  echo "<h3 align=center><font color=#FFFFFF> Vous avez $new_zap points de pouvoir politique </FONT></h3>";
  $un_point= max(0, round(TOUR/(1+$ratio_bonus)-0.5));
  $bonus_par24tours=max(0,round($ratio_bonus*24-0.5));
  echo "<P ALIGN=center>Vous gagnez un point de pouvoir politique par heure.";

  if ($joueur<>"Empire") { // L'empire n'a droit  aucun bonus
    echo" Le niveau de dveloppement de vos toiles est de $som_dev ";
    if ($capitale<>"")
      echo "et vous avez une capitale, ";
    echo "vous gagnez $bonus_par24tours point(s) de pouvoir politique <strong>supplmentaire</strong> tous les ".seconds_to_string(TOUR*24).". <P>";
  }
//
// Pour le debug !!
//echo "som_dev=$som_dev, max_dev_galaxie=$max_dev_galaxie, secondes=$secondes, ratio_bonus=$ratio_bonus, delta_secondes_brut=$delta_secondes_brut, delta_zap=$delta_zap, new_zap=$new_zap<BR>";
//echo "MAX_ZAP=".MAX_ZAP." reste_seconde=$reste_seconde, delta_secondes_brut=$delta_secondes_brut, max($nrj_zap,".MAX_ZAP.")=".max($nrj_zap,MAX_ZAP);
//echo "nrj_zap=$nrj_zap, max(15,50)=".max(15,50);

}






//-----------------------------------------------
//  PASSE l'ORDRE D'UN JOUEUR
//-----------------------------------------------

function passe_ordre($log, $ordre, $arg1, $arg2, $arg3) {
  affiche("<H3><P>$log, vous avez passe l'ordre : $ordre $arg1 $arg2 $arg3</P></H3>");
// On fait des logs statistiques
/*
$fd=fopen("core/stat.txt","a");
if ($fd!="") {
  fwrite($fd,date("Y-m-d H:i:s").";$ordre\n");
  fclose($fd);
}
// fins des stats
*/
  connecte();
  //journalise ("$log : $ordre $arg1 $arg2 $arg3");
  //Vrouiller la base le temps de passer l'ordre
  $query="SELECT GET_LOCK(\"lock\", 10)";
  requete($query);
   //
  switch($ordre){
    case "DEPLACER" :
      if (verif_entier($arg3))
         deplace_flotte($log, $arg1, $arg2, $arg3);
      else echo "<B> Je ne comprend pas cet ordre <B><BR>";
      break;
    case "DEVELOPPER":
      developpe_systeme($log, $arg1);
      break;
    case "MESSAGE" :
      envoyer_message($log, $arg1, $arg2);
      break;
    case "SUREXPLOITER" :
      surexploite_systeme($log,$arg1);
      break;
    case "PRODUIRE" :
      produit_vaisseaux($log, $arg1);
      break;
    case "VORTEX" :
      if (a_techno($log, VORTEX)) ouvre_vortex($log, $arg1, $arg2);
      else echo "<B> Je ne comprend pas cet ordre <B><BR>";
      break;
    case "TERRAFORMER" :
      if (a_techno($log, TERRA)) terraformer_systeme($log, $arg1, $arg2);
      else echo "<B> Je ne comprend pas cet ordre <B><BR>";
      break;
    case "ATOMISER" :
      if (a_techno($log, ATOM)) atomiser_systeme($log, $arg1);
      else echo "<B> Je ne comprend pas cet ordre <B><BR>";
      break;
    case "HYPERFORMER" :
      if (a_techno($log, HYPER)) hyperformer_systeme($log, $arg1);
      else echo "<B> Je ne comprend pas cet ordre <B><BR>";
      break;
    case "RAIL" :
      if (a_techno($log, RAIL)) creer_rail($log, $arg1, $arg2);
      else echo "<B> Je ne comprend pas cet ordre <B><BR>";
      break;
   case "PROTECTORAT" :
      if (a_techno($log, PREPRO)) protectorat($log);
      else echo "<B> Je ne comprend pas cet ordre <B><BR>";
      break;
   case "COLONISER" :
      coloniser($log, $arg1);
      break;
   case "MEGAPHONE" :
      if ($log=="Empire" || $log=="") megaphone($log, $arg1);
      else echo "<B> Je ne comprend pas cet ordre <B><BR>";
      break;
   case "CAPITALE" :
      if (($log<>"Empire") && (a_techno($log,CAPITALE))) capitale($log, $arg1);
      else echo "<B> Je ne comprend pas cet ordre <B><BR>";
      break;
   case "VOTER" :
      if (($log<>"Empire") && (a_techno($log,VOTE))) voter($log, $arg1);
      else echo "<B> Je ne comprend pas cet ordre <B><BR>";
      break;
   case "CONVOQUER" :
      if (($log<>"Empire") && (a_techno($log,VOTE))) convoquer($log);
      else echo "<B> Je ne comprend pas cet ordre <B><BR>";
      break;
   case "ESPIONNER" :
      if ($log=="Empire") espionner($log, $arg1);
      else echo "<B> Je ne comprend pas cet ordre <B><BR>";
      break;
   case "PROPAGANDE" :
      if ($log=="Empire") propagande($log);
      else echo "<B> Je ne comprend pas cet ordre <B><BR>";
      break;
   case "REBELLION" :
      if ($log=="Empire") rebellion($log, $arg1);
      else echo "<B> Je ne comprend pas cet ordre <B><BR>";
      break;
  }
  // Relacher la base
  $query="SELECT RELEASE_LOCK(\"lock\")";
  requete($query);
  return get_affichage();
}

//-----------------------------------------------
//  FAIT PROGESSER LE NIVEAU D'ANOMALIE SI NECESSAIRE
//     si l'empire a moins de MAX_ANO3% des toiles -> anomalie 3
//     si l'empire a moins de MAX_ANO4% des toiles -> anomalie 4
//-----------------------------------------------
function check_ano() {

    $ano_actuel=anomalie();
    connecte();
    // nb d'toile de l'empire
    $query="SELECT count(*) FROM systemes WHERE pseudo=\"Empire\"";
    $result = requete($query);
    $row = mysql_fetch_row($result);
    $nb_empire =$row[0];
    // nb d'toile dans la galaxie
    $query="SELECT count(*) FROM systemes";
    $result = requete($query);
    $row = mysql_fetch_row($result);
    $nb_max=$row[0];
    //mysql_close();
    //

    $pourcent=100*$nb_empire/$nb_max;
    if ($pourcent <= MAX_ANO3 && $ano_actuel <3) { //On dclenche l'anomalie 3
        connecte();
        $msg="***Nous, les descendants des sages prolarch' avons dcid d'intervenir face  tant de brutalit.";
        $msg.= " L'empire a vcu et il ne se relvera pas, puissiez-vous tre meilleurs.";
        $msg.= " Nous vous confions solennellement le vortex pour vous donner les moyens de vous rapprocher les";
        $msg .=" uns des autres pour que vous puissiez trouver ensemble la voie de la paix.";
        $msg.= " Paix qui devra arriver QUELS QUE SOIENT les moyens que nous utiliserons.";
        message("","",$msg);
        //mysql_close();
        anomalie(3);
    }
    if ($pourcent <= MAX_ANO4 && $ano_actuel <4) { //On dclenche l'anomalie 4
        connecte();
        $debut=time()+TOUR*24*DEBUT_FIN;
        $fin_max=$debut+TOUR*24*(DELAI_FIN);
        mt_srand(time());
        $fin=mt_rand($debut,$fin_max);
        $msg="***Nous,les descendants des sages prolach' sommes consterns face  tant de stupidit. ";
        $msg.="Nous avons donc dcid avec le Kloch' que nous laisserons la stupidit vous dpartager. ";
        $msg.="Nous confions l'arme ultime  ceux qui peuvent la matriser. Celui qui saura en faire le ";
        $msg.="meilleur usage pour devenir le premier de l'ensemble de la galaxie sera considr comme l'lu  nos yeux. ";
        $msg.="Nous ferons notre choix  un moment choisi entre le ".date_to_string($debut)." et le ".date_to_string($fin_max+TOUR*24*DELAI_MARGE);
        $msg.=" en revanche, si la galaxie venait  trop se rduire, nous serions contraint d'liminer les humains de cet univers.";
        message("","",$msg);
        parametre("fin",$fin);
        anomalie(4);
        //mysql_close();
    }

}

//-----------------------------------------------
//  VERIFIE SI LA PARTIE EST TERMINEE
//     Si plus de 1/3 des toiles ont disparues, les prolarch's attaquent
//-----------------------------------------------
function check_fin() {
  // nb d'toiles au dbut
  $etoiles_max= parametre("etoiles_max");
  // nb d'toiles actuellement
  connecte();
  $query="SELECT COUNT(*), sum(dev) FROM systemes";
  $result = requete($query);
  $row = mysql_fetch_row($result);
  $etoile_now =$row[0];
  $total_dev=$row[1];
  $fin=($etoile_now/$etoiles_max)< P_ATOM;

  if($fin) {
   $joueur="Prolarch";
   // remplir le 'hall of fame'
   $dat=time();
   $query = "INSERT INTO fame (date, gagnant1, gagnant2, gagnant3) VALUES ($dat, 'Prolarch','','')";
   requete($query);
   }
  else {
    $date_de_fin= parametre("fin");
    connecte();
    if(($date_de_fin!="") && (time()>$date_de_fin)){ // On vrifie si un joueur n'a pas gagn
      $query="DELETE from vieux_class";
      requete($query);
      $query="INSERT INTO vieux_class (joueur, couleur, dev, etoile) SELECT pseudo, couleur, sum(dev), count(pseudo) FROM systemes, joueurs WHERE pseudo=login GROUP BY pseudo";
      requete($query);
      $query ="SELECT dev+etoile valeur, joueur FROM vieux_class ORDER BY valeur DESC";
      $result = requete($query);
      $row = mysql_fetch_row($result);
      $joueur=$row[1];
      $fin=$joueur;
      // remplir le 'hall of fame'
      $j1=$joueur;
      $row = mysql_fetch_row($result);
      $j2=$row[1];
      $row = mysql_fetch_row($result);
      $j3=$row[1];
      $co="Dev global de la galaxie : $total_dev pour $etoile_now etoiles";
      $empereur=parametre("ELU");
      if ($empereur<>"")
         $co.="<BR><BR>Empereur : $empereur";
      $dat=time();
      $query = "INSERT INTO fame (date, gagnant1, gagnant2, gagnant3, comment) VALUES ($dat, \"$j1\", \"$j2\", \"$j3\", \"$co\")";
      requete($query);
    }
   }
   if ($fin) {
    journalise("Vainqueur :$joueur");
    //mysql_close();
    genere_partie();
    parametre("vainqueur",$joueur);
  }
  else{
    //mysql_close();
  }
  return $fin;
}

//-----------------------------------------------
//  CONNECTE UN JOUEUR
//-----------------------------------------------
function log_joueur($log, $pwd) {

  global $REMOTE_ADDR;

  // on fait le mnage parmis les joueurs en attente d'adbdication
  purge_abdique();
  
  $ip=$REMOTE_ADDR;
  $fqn= gethostbyaddr($ip);
  $moment=time();
//  echo $fqn;
  if (strstr($fqn,'anonimizer') ||(strstr($fqn,'nantes')&&strstr($fqn,'dial.proxad.net'))) {
      journalise("blocage de nom de domaine:$fqn , log:$log, pwd:$pwd");
	  sleep(10);
      quitte("Erreur d'authentification");
    }
  connecte();
  // Vrification de l'existence du login
  $query = "SELECT login, nb_echec FROM joueurs WHERE login =\"$log\" AND pwd =\"$pwd\" AND (nb_echec <4 OR ip_lock<>\"$ip\" OR (date_lock < $moment AND ip_lock=\"$ip\") )";
  $result = requete($query);
  if (mysql_num_rows($result)==0) {
      $res=""; //Ne pas permettre au joueur de se connecter
	  $ko=FALSE;
	  $query="SELECT * FROM  joueurs WHERE login =\"$log\" AND pwd =\"$pwd\"";
	  $result = requete($query);
	  if (mysql_num_rows($result)!=0) { // le joueur existe mais a t bloqu pour trop de tentative de connexion errone 
	     $ko=TRUE;
	  }
	  else {
        $query = "SELECT * FROM vieux_joueurs vj WHERE vj.login =\"$log\" AND vj.pwd =\"$pwd\"";
        $result = requete($query);
		$ko |= (mysql_num_rows($result)==0);
	  }
      if ($ko) { // Le joueur est bloqu on n'existe pas dans les anciens joueurs
	      journalise("Connexion rejete $log, mot de passe $pwd");
		  // On incrmente le compteur d'chec et on affiche l'erreur
		  $query="UPDATE joueurs SET nb_echec=nb_echec+1, ip_lock=\"$ip\", date_lock=$moment+3600 WHERE login=\"$log\"";
		  $result = requete($query);
		  sleep(10);
		  affiche_enteteHTML();
          echo "<B>Ce joueur et/ou ce mot de passe n'existe pas</B><BR>";
          echo ("<BR><a href=\".\"> Revenir  la page d'accueil </a> <BR>");
          
      }
      else { // Il s'agit d'un vieux joueur, lui dire que c'est fini et qui a gagn
         affiche_enteteHTML();
         affiche_partie_finie();
      }
  }
  else {
    $row = mysql_fetch_row($result);
    $login = $row[0];
	$nb_echec =$row[1];
	if ($nb_echec!=0){ // Remettre le compteur  0
	   $query="UPDATE joueurs SET nb_echec=0 WHERE login=\"$login\"";
	   requete($query);
	}
    $res = $login;
	$date=time();
	if (parametre("cookie1h")=="ok"){
	  setcookie("login",$login,time()+3600*LIMITE_CNX);
	  setcookie("date",$date,time()+3600*LIMITE_CNX);
	  setcookie("cle",md5($login.$date.SECRET), time()+3600*LIMITE_CNX);
	}
	else{
      setcookie("login",$login);
	  setcookie("date",$date);
      setcookie("cle",md5($login.$date.SECRET));
	}
    journalise("Connexion russie de $log");

  }
  // Deconnexion de la base de donnees
  //mysql_close;
  return $res;
}

?>
